; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL flen      :DWORD          ; file length
    LOCAL pMem      :DWORD          ; file memory pointer
    LOCAL pcl       :DWORD          ; pointer to command line buffer
    LOCAL buf[260]  :BYTE           ; 260 byte buffer
    LOCAL pArray    :DWORD
    LOCAL acnt      :DWORD          ; array member count

    mov pcl, ptr$(buf)              ; load address of buffer into pointer

    .if rv(GetCL, 1, pcl) != 1      ; check if there is a command line
      jmp clerror
    .endif

    .if rv(exist,pcl) != 1          ; check if the file exists
      jmp no_file
    .endif

    mov pMem, InputFile(pcl)        ; load file into memory
    mov flen, ecx                   ; get the file length

  ; -----------------------------------------------
  ; tokenise the lines in the text file and produce
  ; an array of pointers to the lines of text
  ; -----------------------------------------------
    mov acnt, rv(ltok,pMem,ADDR pArray)

    invoke assort,pArray,acnt,100   ; sort the lines ascending

  ; ---------------------------------
  ; dump the sorted results to STDOUT
  ; ---------------------------------
    push ebx
    push esi

    mov ebx, acnt
    mov esi, pArray

  @@:
    print [esi],13,10
    add esi, 4
    sub ebx, 1
    jnz @B

    pop esi
    pop ebx
  ; ---------------------------------

    free pArray                     ; free the pointer array memory
    free pMem                       ; release the memory when finished

    ret

  no_file:
    print "Hmmmm, I can't find that file",13,10
    ret

  clerror:
    print "It helps if you load a valid file from the command line",13,10
    ret

main endp

; 

end start
